#include "sql.h"

/*----------------------------------------------------------------*/
/*								  */
/*  Example using SQLCPY command				  */
/*								  */
/*  Run EMP.SQL via SQLTALK to initialize tables and data	  */
/*								  */
/*----------------------------------------------------------------*/

	  SQLTCUR   cur1 = 0;		/* select cursor	  */
	  SQLTCUR   cur2 = 0;		/* insert cursor	  */
	  SQLTRCD   rcd1 = 0;		/* return code (cur1)	  */
	  SQLTRCD   rcd2 = 0;		/* return code (cur2)	  */

	  main()
{
static	  char	    select[] =		/* SQL select statement   */
"SELECT EMP_NO,EMP_NAME FROM EMP";
static	  char	    insert[] =		/* SQL insert statement   */
"INSERT INTO TMP (TMP_NO, TMP_NAME) VALUES (:1, :2)";

  /*
     CONNECT TO BOTH CURSORS
  */

  if (sqlcnc(&cur1, "DEMO", 0))
    failure("SELECT CURSOR CONNECT");

  if (sqlcnc(&cur2, "DEMO", 0))
    failure("INSERT CURSOR CONNECT");

  /*
    PERFORM COPY OPERATION
  */

  if (sqlcpy(cur1,select,0,cur2,insert,0))
    failure("COPY OPERATION");

  /*
    COMMIT BOTH CURSORS
  */

  if (sqlcmt(cur1) || sqlcmt(cur2))
    failure("COMMIT");

  /*
    DISCONNECT BOTH CURSORS
  */

  if (sqldis(cur1))
    failure("DISCONNECT OF SELECT CURSOR");

  cur1 = 0;

  if (sqldis(cur2))
    failure("DISCONNECT OF INSERT CURSOR");
}
	  failure(ep)
	  char*     ep; 		/* -> failure msg string  */
{
	  SQLTEPO   epo;		/* error position	  */
	  char	    errmsg[SQLMERR];	/* error msg text buffer  */

  printf("Failure on %s \n", ep);

  sqlrcd(cur1,&rcd1);			/* get return codes	  */
  sqlrcd(cur2,&rcd2);

  if (rcd1)				/* error on cursor 1?	  */
  {
    sqlerr(rcd1, errmsg);
    sqlepo(cur1, &epo);
    printf("%s(error: %u, position: %u) \n",errmsg,rcd1,epo);
  }

  if (rcd2)				/* error on cursor 2?	  */
  {
    sqlerr(rcd2, errmsg);
    sqlepo(cur2, &epo);
    printf("%s(error: %u, position: %u) \n",errmsg,rcd1,epo);
  }

  if (cur1)				/* cursor 1 exists?	  */
    sqldis(cur1);

  if (cur2)				/* cursor 2 exists?	  */
    sqldis(cur2);

  exit(1);
}
